
#include "dijkstra.h"

#include <float.h>
#include <vector>

void dijkstra(multi_array<double, 2> &trav_cost_mtx, multi_array<double, 2> &distance_mtx, multi_array<double, 2> &sp_succ, int vertex_num)
{
	for (int v0 = 0; v0 < vertex_num; v0++) // starting from the vertex v0
	{
		vector<int> found_sp(vertex_num);
		multi_array<double, 2> on_the_sp(extents[vertex_num][vertex_num]);
		vector< vector<int> > sp(vertex_num);

		for (vector< vector<int> >::iterator iter = sp.begin(); iter != sp.end(); iter++)
		{
			iter->push_back(v0);
		}

		for (int v = 0; v < vertex_num; v++)
		{
			found_sp[v] = 0;
			distance_mtx[v0][v] = trav_cost_mtx[v0][v];
			if (distance_mtx[v0][v] < DBL_MAX)
			{
				vector< vector<int> >::iterator iter = sp.begin()+v;
				iter->push_back(v);
			}
		}

		distance_mtx[v0][v0] = 0;
		sp_succ[v0][v0] = v0;
		found_sp[v0] = 1;

		for (int i = 1; i < vertex_num; i++)
		{
			double min_dist = DBL_MAX;

			int next_v = -1;
			for (int w = 0; w < vertex_num; w++)
			{
				if (!found_sp[w])
				{
					if (distance_mtx[v0][w] < min_dist)
					{
						next_v = w;
						min_dist = distance_mtx[v0][w];
					}
				}
			}

			if (next_v == -1)
				break;

			found_sp[next_v] = 1;

			for (int w = 0; w < vertex_num; w++)
			{
				if (!found_sp[w] && min_dist+trav_cost_mtx[next_v][w] < distance_mtx[v0][w])
				{
					distance_mtx[v0][w] = min_dist+trav_cost_mtx[next_v][w];
					vector< vector<int> >::iterator iter1 = sp.begin()+w;
					vector< vector<int> >::iterator iter2 = sp.begin()+next_v;
					*iter1 = *iter2;
					iter1->push_back(w);
				}
			}
		}

		for (vector< vector<int> >::iterator iter = sp.begin(); iter != sp.end(); iter++)
		{
			if (iter->begin() == iter->end()-1)
			{
				sp_succ[*iter->begin()][*iter->begin()] = *iter->begin();
				continue;
			}

			for (vector<int>::iterator iiter = iter->begin(); iiter != iter->end()-1; iiter++)
			{
				sp_succ[*iiter][*(iter->end()-1)] = *(iiter+1);
			}
		}
	}
}